/*  DO NOT EDIT THIS FILE.

    It has been auto-edited by fixincludes from:

	"/usr/include/math.h"

    This had to be done to correct non-standard usages in the
    original, manufacturer supplied header file.  */

#ifndef _MATH_INCLUDED
#define _MATH_INCLUDED

#ifndef _SYS_STDSYMS_INCLUDED
#  include <sys/stdsyms.h>
#endif /* _SYS_STDSYMS_INCLUDED */

#if !defined(__ia64)
#  define _PA_RISC
#endif

#ifdef __cplusplus
extern "C" {
#endif


/********* STANDARD C INTERFACE ********************************/

#if defined(__ia64) && defined(_PROTOTYPES) && \
  (defined(__HP_cc) || defined(__HP_aCC))
#ifndef HUGE_VAL
#  define HUGE_VAL   ((double)_Infinity) 
#endif
#else
#ifndef HUGE_VAL
#  define HUGE_VAL   _DINFINITY
#endif
#endif

#if defined(_PA_RISC) && !defined(__cplusplus)
#  pragma NO_SIDE_EFFECTS fabs
#  ifdef __BUILTIN_MATH
#    pragma NO_SIDE_EFFECTS acos, asin, atan, atan2, cos, sin, tan
#    pragma NO_SIDE_EFFECTS cosh, sinh, tanh
#    pragma NO_SIDE_EFFECTS exp, ldexp, log, log10, pow
#    pragma NO_SIDE_EFFECTS sqrt, ceil, floor, fmod
#  endif
#endif /* #if for pragmas */

#ifdef __ia64
#  pragma builtin acos, asin, atan, atan2, cos, sin, tan, cosh, sinh, tanh, \
                  exp, ldexp, log, log10, modf, pow, sqrt, ceil, \
                  fabs, floor, fmod  
#endif /* __ia64 */

#ifdef _PROTOTYPES 
_NAMESPACE_STD_START
   extern double acos(double);
   extern double asin(double);
   extern double atan(double);
   extern double atan2(double, double);
   extern double cos(double);
   extern double sin(double);
   extern double tan(double);
   extern double cosh(double);
   extern double sinh(double);
   extern double tanh(double);
   extern double exp(double);
   extern double frexp(double, int *);
   extern double ldexp(double, int);
   extern double log(double);
   extern double log10(double);
   extern double modf(double, double *);
   extern double pow(double, double);
   extern double sqrt(double);
   extern double ceil(double);
   extern double fabs(double);
   extern double floor(double);
   extern double fmod(double, double);
_NAMESPACE_STD_END
#  ifdef __ia64
#    pragma builtin acosf, asinf, atanf, atan2f, cosf, sinf, tanf, coshf, \
                    sinhf, tanhf, expf, ldexpf, logf, log10f, modff, \
                    powf, sqrtf, ceilf, fabsf, floorf, fmodf  
     extern float acosf(float);
     extern float asinf(float);
     extern float atanf(float);
     extern float atan2f(float, float);
     extern float cosf(float);
     extern float sinf(float);
     extern float tanf(float);
     extern float coshf(float);
     extern float sinhf(float);
     extern float tanhf(float);
     extern float expf(float);
     extern float frexpf(float, int *);
     extern float ldexpf(float, int);
     extern float logf(float);
     extern float log10f(float);
     extern float modff(float, float *);
     extern float powf(float, float);
     extern float sqrtf(float);
     extern float ceilf(float);
     extern float fabsf(float);
     extern float floorf(float);
     extern float fmodf(float, float);

#    pragma builtin acosl, asinl, atanl, atan2l, cosl, sinl, tanl, coshl, \
                    sinhl, tanhl, expl, ldexpl, logl, log10l, modfl, \
                    powl, sqrtl, ceill, fabsl, floorl, fmodl  
     extern long double acosl(long double);
     extern long double asinl(long double);
     extern long double atanl(long double);
     extern long double atan2l(long double, long double);
     extern long double cosl(long double);
     extern long double sinl(long double);
     extern long double tanl(long double);
     extern long double coshl(long double);
     extern long double sinhl(long double);
     extern long double tanhl(long double);
     extern long double expl(long double);
     extern long double frexpl(long double, int *);
     extern long double ldexpl(long double, int);
     extern long double logl(long double);
     extern long double log10l(long double);
     extern long double modfl(long double, long double *);
     extern long double powl(long double, long double);
     extern long double sqrtl(long double);
     extern long double ceill(long double);
     extern long double fabsl(long double);
     extern long double floorl(long double);
     extern long double fmodl(long double, long double);
#  endif /* __ia64 */
#else /* not _PROTOTYPES */
   extern double acos();
   extern double asin();
   extern double atan();
   extern double atan2();
   extern double cos();
   extern double sin();
   extern double tan();
   extern double cosh();
   extern double sinh();
   extern double tanh();
   extern double exp();
   extern double frexp();
   extern double ldexp();
   extern double log();
   extern double log10();
   extern double modf();
   extern double pow();
   extern double sqrt();
   extern double ceil();
   extern double fabs();
   extern double floor();
   extern double fmod();
#endif /* _PROTOTYPES */


/********* XOPEN EXTENSIONS ***********************************/ 

#ifdef _INCLUDE_XOPEN_SOURCE

#  define M_E           2.7182818284590452354
#  define M_LOG2E       1.4426950408889634074
#  define M_LOG10E      0.43429448190325182765
#  define M_LN2         0.69314718055994530942
#  define M_LN10        2.30258509299404568402
#  define M_PI          3.14159265358979323846
#  define M_PI_2        1.57079632679489661923
#  define M_PI_4        0.78539816339744830962
#  define M_1_PI        0.31830988618379067154
#  define M_2_PI        0.63661977236758134308
#  define M_2_SQRTPI    1.12837916709551257390
#  define M_SQRT2       1.41421356237309504880
#  define M_SQRT1_2     0.70710678118654752440
#  define MAXFLOAT      ((float)3.40282346638528860e+38)

   extern int signgam;

#  if defined(_PA_RISC) && !defined(__cplusplus)
#    pragma NO_SIDE_EFFECTS isnan
#    ifdef __BUILTIN_MATH
#      pragma NO_SIDE_EFFECTS acosh, asinh, atanh, rint, scalb, logb, cbrt
#      pragma NO_SIDE_EFFECTS nextafter, remainder, expm1, ilogb, log1p
#    endif
#  endif

#  ifdef __ia64
#    pragma builtin erf, erfc, gamma, hypot, isnan, j0, j1, jn, lgamma, \
                    y0, y1, yn 
#  endif /* __ia64 */

#  ifdef _PROTOTYPES
     extern double erf(double);
     extern double erfc(double);
     extern double gamma(double);                             /* obsolescent */
     extern double hypot(double, double);
     extern int    isnan(double);
     extern double j0(double);
     extern double j1(double);
     extern double jn(int, double);
     extern double lgamma(double);
     extern double y0(double);
     extern double y1(double);
     extern double yn(int, double);
#  else /* not _PROTOTYPES */
     extern double erf();
     extern double erfc();
     extern double gamma();                                   /* obsolescent */
     extern double hypot();
     extern int    isnan();
     extern double j0();
     extern double j1();
     extern double jn();
     extern double lgamma();
     extern double y0();
     extern double y1();
     extern double yn();
#  endif /* _PROTOTYPES */

#endif /* _INCLUDE_XOPEN_SOURCE */

#ifdef _INCLUDE_XOPEN_SOURCE_EXTENDED

#  ifdef __ia64
#    pragma builtin acosh, asinh, atanh, cbrt, expm1, ilogb, log1p, logb, \
                    nextafter, remainder, rint, scalb 
#  endif /* __ia64 */

#  ifdef _PROTOTYPES
     extern double acosh(double);
     extern double asinh(double);
     extern double atanh(double);
     extern double cbrt(double);
     extern double expm1(double);
     extern int    ilogb(double);
     extern double log1p(double);
     extern double logb(double);
     extern double nextafter(double, double);
     extern double remainder(double, double);
     extern double rint(double);
     extern double scalb(double,double);
#  else /* not _PROTOTYPES */
     extern double acosh();
     extern double asinh();
     extern double atanh();
     extern double cbrt();
     extern double expm1();
     extern int    ilogb();
     extern double log1p();
     extern double logb();
     extern double nextafter();
     extern double remainder();
     extern double rint();
     extern double scalb();
#  endif /* _PROTOTYPES */

#endif /* _INCLUDE_XOPEN_SOURCE_EXTENDED */


/******** HPUX EXTENSIONS *************************************/ 

#ifdef _INCLUDE_HPUX_SOURCE

#  if defined(__STDC__) || defined(__cplusplus)
#    if !defined(_FLT_EVAL_METHOD) || (_FLT_EVAL_METHOD == 0)
       typedef float float_t;
       typedef double double_t;
#    elif defined(_FLT_EVAL_METHOD) && (_FLT_EVAL_METHOD == 1)
       typedef double float_t;
       typedef double double_t;
#    elif defined(_FLT_EVAL_METHOD) && (_FLT_EVAL_METHOD == -2)    
       typedef __float80 float_t;
       typedef __float80 double_t;
#    endif
#  endif

#  if defined(__ia64) && defined(_PROTOTYPES)
#    ifdef _FPWIDETYPES
#      ifndef _INCLUDE_QUAD
         typedef __float128 quad;
#        define _INCLUDE_QUAD
#      endif
#      ifndef _INCLUDE_EXTENDED
         typedef __float80 extended;
#        define _INCLUDE_EXTENDED
#      endif
#    endif /* _FPWIDETYPES */
#    if defined(__HP_cc) || defined(__HP_aCC)
#      define HUGE_VALF     _Infinity 
#      define HUGE_VALL     ((__float128)_Infinity)
#    else
#      define HUGE_VALF     _SINFINITY 
#      define HUGE_VALL     _LINFINITY
#    endif
#    ifdef _FPWIDETYPES
#      define HUGE_VALW     ((__float80)_Infinity) 
#      define HUGE_VALQ     ((__float128)_Infinity) 
#    endif
#  else
#    define HUGE_VALF     _SINFINITY
#  endif

#  if defined(__ia64) && (defined(__HP_cc) || defined(__HP_aCC))  && \
  defined(_PROTOTYPES)
#    define INFINITY      _Infinity
#    define NAN           _Nan
#  else
#    define INFINITY      _SINFINITY
#    define NAN           _SQNAN
#  endif

#  define FP_ILOGB0	(-2147483647 - 1)
#  define FP_ILOGBNAN	(-2147483647 - 1)

#  ifdef __ia64
#    define MATH_ERRNO     1
#    define MATH_ERREXCEPT 2
#    ifdef _Math_errhandling
#      define math_errhandling  _Math_errhandling
#    else
#      define math_errhandling  MATH_ERREXCEPT
#    endif
#  endif

#if defined(_PA_RISC) || !defined(__cplusplus)
#  define isnan(x)		_ISNAN(x)
#  define isinf(x)		_ISINF(x)
#  define signbit(x)		_SIGNBIT(x)
#  define isfinite(x)		_ISFINITE(x)
#  define isnormal(x)		_ISNORMAL(x)
#  define fpclassify(x)		_FPCLASSIFY(x)
#  define isunordered(x,y)	_ISUNORDERED(x,y)
#  define isgreater(x,y)	_ISGREATER(x,y)
#  define isgreaterequal(x,y)	_ISGREATEREQUAL(x,y)
#  define isless(x,y)		_ISLESS(x,y)
#  define islessequal(x,y)	_ISLESSEQUAL(x,y)
#  define islessgreater(x,y)	_ISLESSGREATER(x,y)
#endif

#  define FP_NORMAL     0
#  define FP_ZERO       1
#  define FP_INFINITE   2
#  define FP_SUBNORMAL  3
#  define FP_NAN        4

#  ifdef __ia64
#    define FP_FAST_FMA
#    define FP_FAST_FMAF
#    ifdef _FPWIDETYPES
#      define FP_FAST_FMAW
#    endif
#  endif

#  ifdef __ia64
#    define DECIMAL_DIG 36 
#  else
#    define DECIMAL_DIG 17
#  endif

#  if defined(_PA_RISC) && !defined(__cplusplus)
#    pragma NO_SIDE_EFFECTS copysign, copysignf, fabsf
#    pragma NO_SIDE_EFFECTS _Fpclassify, _Fpclassifyf, _Fpclassifyfd
#    pragma NO_SIDE_EFFECTS _Isunordered, _Isunorderedf
#    pragma NO_SIDE_EFFECTS _Signbit, _Signbitf, _Isnanf, _Isinf, _Isinff
#    pragma NO_SIDE_EFFECTS _Isfinite, _Isfinitef, _Isnormal, _Isnormalf, _Isnormalfd
#    ifdef __BUILTIN_MATH
#      pragma NO_SIDE_EFFECTS acosd, asind, atand, atan2d, cosd, sind, tand, log2
#      pragma NO_SIDE_EFFECTS acosf, asinf, atanf, atan2f, cosf, sinf, tanf
#      pragma NO_SIDE_EFFECTS coshf, sinhf, tanhf, acosdf, asindf, atandf, atan2df
#      pragma NO_SIDE_EFFECTS cosdf, sindf, tandf, expf, logf, log10f, log2f
#      pragma NO_SIDE_EFFECTS powf, sqrtf, fmodf, cbrtf
#    endif
#  endif /* #if for pragmas */

#  ifdef __ia64
#    pragma builtin copysign, log2, exp2, fdim, fmax, fmin, nan, \
                    scalbn, nearbyint, round, trunc, lrint, lround, \
                    _iround, cosd, sind, tand, exp10, pown, compound, \
                    annuity, fma, scalbln, tgamma, nexttoward, acosd, asind, \
                    atand, atan2d, _iceil, _ifloor, rsqrt
#    if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#      pragma builtin llrint, llround, powlln, _llceil, _llfloor
#    endif /* defined(__STDC_EXT__) || ... */
#  endif /* __ia64 */  

#  ifdef _PROTOTYPES
     extern double copysign(double, double);
     extern double log2(double);
     extern double lgamma_r(double, int *);
     extern double exp2(double);
     extern double fdim(double, double);
     extern double fmax(double, double);
     extern double fmin(double, double);
     extern double nan(const char *);
     extern double scalbn(double, int);
     extern double nearbyint(double);
     extern double round(double);
     extern double trunc(double);
     extern double remquo(double, double, int *);
     extern long   lrint(double);
     extern long   lround(double);
#    if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
       extern long long llrint(double);
       extern long long llround(double);
#    endif
     extern double cosd(double);
     extern double sind(double);
     extern double tand(double);
#    ifdef __ia64
       extern double    exp10(double);
       extern double    pown(double, int);
       extern int	_iround(double);
       extern int	_iceil(double);
       extern int	_ifloor(double);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
         extern double    powlln(double, long long);
         extern long long _llceil(double);
         extern long long _llfloor(double);
#      endif
       extern double    compound(double, double);
       extern double    annuity(double, double);
       extern double    fma(double, double, double);
       extern double    scalbln(double, long);
       extern double    tgamma(double);
       extern double 	nexttoward(double, long double);
       extern double    rsqrt(double);
#    endif /* __ia64 */
     extern double acosd(double);
     extern double asind(double);
     extern double atand(double);
     extern double atan2d(double, double);

#    ifdef _PA_RISC
       extern float acosf(float);
       extern float asinf(float);
       extern float atanf(float);
       extern float atan2f(float, float);
       extern float cosf(float);
       extern float sinf(float);
       extern float tanf(float);
       extern float coshf(float);
       extern float sinhf(float);     
       extern float tanhf(float);
       extern float expf(float);
       extern float logf(float);
       extern float log10f(float);
       extern float powf(float, float);
       extern float sqrtf(float);
       extern float fabsf(float);
       extern float fmodf(float, float);
#    endif /* _PA_RISC */

#    ifdef __ia64
#      pragma builtin cbrtf, copysignf, nextafterf, log2f, cosdf, sindf, \
                  tandf, acosdf, asindf, atandf, atan2df, exp2f, exp10f, \
                  expm1f, log1pf, pownf, fmaf, acoshf, asinhf, atanhf, \
                  logbf, scalbf, scalbnf, scalblnf, ilogbf, hypotf, \
                  compoundf, annuityf, erff, erfcf, gammaf, lgammaf, \
                  tgammaf, nearbyintf, rintf, roundf, lrintf, \
                  lroundf, _iroundf, truncf, nanf, remainderf, \
                  fdimf, fmaxf, fminf, nexttowardf, _iceilf, _ifloorf, \
                  rsqrtf
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#        pragma builtin powllnf, llrintf, llroundf, _llceilf, \
         _llfloorf 
#      endif /* defined(__STDC_EXT__) || ... */
#    endif /* __ia64 */

     extern float cbrtf(float);
     extern float copysignf(float, float);
     extern float nextafterf(float, float);
     extern float log2f(float);
     extern float cosdf(float);
     extern float sindf(float);
     extern float tandf(float);
     extern float acosdf(float);
     extern float asindf(float);
     extern float atandf(float);
     extern float atan2df(float, float);
#    ifdef __ia64
       extern float exp2f(float);
       extern float exp10f(float);
       extern float expm1f(float);
       extern float log1pf(float);
       extern float pownf(float, int);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
         extern float powllnf(float, long long);
#      endif
       extern float fmaf(float, float, float);
       extern float acoshf(float);
       extern float asinhf(float);
       extern float atanhf(float);
       extern float logbf(float);
       extern float scalbf(float, float);
       extern float scalbnf(float, int);
       extern float scalblnf(float, long);
       extern int   ilogbf(float);
       extern float hypotf(float, float);
       extern float compoundf(float, float);
       extern float annuityf(float, float);
       extern float erff(float);
       extern float erfcf(float);
       extern float gammaf(float);
       extern float lgammaf(float);
       extern float lgammaf_r(float, int *);
       extern float tgammaf(float);
       extern float nearbyintf(float);
       extern float rintf(float);
       extern float roundf(float);
       extern long  lrintf(float);
       extern long  lroundf(float);
       extern int   _iroundf(float);
       extern int   _iceilf(float);
       extern int   _ifloorf(float);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
         extern long long llrintf(float);
         extern long long llroundf(float);
         extern long long _llceilf(float);
         extern long long _llfloorf(float);
#      endif
       extern float truncf(float);
       extern float nanf(const char *);
       extern float remainderf(float, float);
       extern float remquof(float, float, int *);
       extern float fdimf(float, float);
       extern float fmaxf(float, float);
       extern float fminf(float, float);
       extern float nexttowardf(float, long double);
       extern float rsqrtf(float);

#      ifdef _FPWIDETYPES
#        pragma builtin acosw, asinw, atanw, atan2w, cosw, sinw, tanw, \
                        acosdw, asindw, atandw, atan2dw, cosdw, sindw, tandw, \
                        coshw, sinhw, tanhw, acoshw, asinhw, atanhw, expw, \
                        exp2w, exp10w, expm1w, logw, log2w, log10w, log1pw, \
                        poww, ldexpw, modfw, logbw, scalbw, scalbnw, \
                        scalblnw, ilogbw, fabsw, sqrtw, cbrtw, hypotw, \
                        compoundw, annuityw, erfw, erfcw, gammaw, lgammaw, \
                        tgammaw, ceilw, floorw, nearbyintw, rintw, \
                        roundw, lrintw, lroundw, _iroundw, truncw, nanw, \
                        fmodw, remainderw, copysignw, nextafterw, \
                        nexttowardw, fdimw, fmaxw, fminw, fmaw, pownw, \
			_iceilw, _ifloorw, rsqrtw
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#           pragma builtin powllnw, llrintw, llroundw, _llceilw, _llfloorw 
#        endif /* defined(__STDC_EXT__) || ... */
         extern __float80 acosw(__float80);
         extern __float80 asinw(__float80);
         extern __float80 atanw(__float80);
         extern __float80 atan2w(__float80, __float80);
         extern __float80 cosw(__float80);
         extern __float80 sinw(__float80);
         extern __float80 tanw(__float80);
         extern __float80 acosdw(__float80);
         extern __float80 asindw(__float80);
         extern __float80 atandw(__float80);
         extern __float80 atan2dw(__float80, __float80);
         extern __float80 cosdw(__float80);
         extern __float80 sindw(__float80);
         extern __float80 tandw(__float80);
         extern __float80 coshw(__float80);
         extern __float80 sinhw(__float80);
         extern __float80 tanhw(__float80);
         extern __float80 acoshw(__float80);
         extern __float80 asinhw(__float80);
         extern __float80 atanhw(__float80);
         extern __float80 expw(__float80);
         extern __float80 exp2w(__float80);
         extern __float80 exp10w(__float80);
         extern __float80 expm1w(__float80);
         extern __float80 logw(__float80);
         extern __float80 log2w(__float80);
         extern __float80 log10w(__float80);
         extern __float80 log1pw(__float80);
         extern __float80 poww(__float80, __float80);
         extern __float80 pownw(__float80, int);
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
           extern __float80 powllnw(__float80, long long);
#        endif
         extern __float80 frexpw(__float80, int *);
         extern __float80 ldexpw(__float80, int);
         extern __float80 modfw(__float80, __float80 *);
         extern __float80 logbw(__float80);
         extern __float80 scalbw(__float80, __float80);
         extern __float80 scalbnw(__float80, int);
         extern __float80 scalblnw(__float80, long);
         extern int       ilogbw(__float80);
         extern __float80 fabsw(__float80);
         extern __float80 sqrtw(__float80);
         extern __float80 cbrtw(__float80);
         extern __float80 hypotw(__float80, __float80);
         extern __float80 compoundw(__float80, __float80);
         extern __float80 annuityw(__float80, __float80);
         extern __float80 erfw(__float80);
         extern __float80 erfcw(__float80);
         extern __float80 gammaw(__float80);
         extern __float80 lgammaw(__float80);
         extern __float80 lgammaw_r(__float80, int *);
         extern __float80 tgammaw(__float80);
         extern __float80 ceilw(__float80);
         extern __float80 floorw(__float80);
         extern __float80 nearbyintw(__float80);
         extern __float80 rintw(__float80);
         extern __float80 roundw(__float80);
         extern long      lrintw(__float80);
         extern long      lroundw(__float80);
         extern int       _iroundw(__float80);
         extern int       _iceilw(__float80);
         extern int       _ifloorw(__float80);
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
           extern long long llrintw(__float80);
           extern long long llroundw(__float80);
           extern long long _llceilw(__float80);
           extern long long _llfloorw(__float80);
#        endif
         extern __float80 truncw(__float80);
         extern __float80 nanw(const char *);
         extern __float80 fmodw(__float80, __float80);
         extern __float80 remainderw(__float80, __float80);
         extern __float80 remquow(__float80, __float80, int *);
         extern __float80 copysignw(__float80, __float80);
         extern __float80 nextafterw(__float80, __float80);
         extern __float80 nexttowardw(__float80, __float128);
         extern __float80 fdimw(__float80, __float80);
         extern __float80 fmaxw(__float80, __float80);
         extern __float80 fminw(__float80, __float80);
         extern __float80 fmaw(__float80, __float80, __float80);
         extern __float80 rsqrtw(__float80);
#      endif /* _FPWIDETYPES */

#      pragma builtin acosdl, asindl, atandl, atan2dl, acoshl, asinhl, \
                      atanhl, cosdl, sindl, tandl, exp2l, exp10l, expm1l, \
                      log2l, log1pl, logbl, scalbl, scalbnl, scalblnl, \
                      ilogbl, fabsl, pownl, hypotl, cbrtl, compoundl, \
                      annuityl, erfl, erfcl, gammal, lgammal, \
                      tgammal, nearbyintl, rintl, roundl, lrintl, lroundl, \
                      _iroundl, truncl, nanl, remainderl, copysignl, \
                      nextafterl, nexttowardl, fdiml, fmaxl, fminl, fmal, \
		      _iceill, _ifloorl, rsqrtl
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#         pragma builtin powllnl, llrintl, llroundl, _llceill, _llfloorl 
#      endif /* defined(__STDC_EXT__) || ... */
       extern long double acosdl(long double);
       extern long double asindl(long double);
       extern long double atandl(long double);
       extern long double atan2dl(long double, long double);
       extern long double acoshl(long double);
       extern long double asinhl(long double);
       extern long double atanhl(long double);
       extern long double cosdl(long double);
       extern long double sindl(long double);
       extern long double tandl(long double);
       extern long double exp2l(long double);
       extern long double exp10l(long double);
       extern long double expm1l(long double);
       extern long double log2l(long double);
       extern long double log1pl(long double);
       extern long double logbl(long double);
       extern long double scalbl(long double, long double);
       extern long double scalbnl(long double, int);
       extern long double scalblnl(long double, long);
       extern int        ilogbl(long double);
       extern long double pownl(long double, int);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
         extern long double powllnl(long double, long long);
#      endif
       extern long double hypotl(long double, long double);
       extern long double cbrtl(long double);
       extern long double compoundl(long double, long double);
       extern long double annuityl(long double, long double);
       extern long double erfl(long double);
       extern long double erfcl(long double);
       extern long double gammal(long double);
       extern long double lgammal(long double);
       extern long double lgammal_r(long double, int *);
       extern long double tgammal(long double);
       extern long double nearbyintl(long double);
       extern long double rintl(long double);
       extern long double roundl(long double);
       extern long      lrintl(long double);
       extern long      lroundl(long double);
       extern int        _iroundl(long double);
       extern int        _iceill(long double);
       extern int        _ifloorl(long double);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
         extern long long llrintl(long double);
         extern long long llroundl(long double);
         extern long long _llceill(long double);
         extern long long _llfloorl(long double);
#      endif
       extern long double truncl(long double);
       extern long double nanl(const char *);
       extern long double remainderl(long double, long double);
       extern long double remquol(long double, long double, int *);
       extern long double copysignl(long double, long double);
       extern long double nextafterl(long double, long double);
       extern long double nexttowardl(long double, long double);
       extern long double fdiml(long double, long double);
       extern long double fmaxl(long double, long double);
       extern long double fminl(long double, long double);
       extern long double fmal(long double, long double, long double);
       extern long double rsqrtl(long double);
#      ifdef _FPWIDETYPES
#        pragma builtin acosq, asinq, atanq, atan2q, cosq, sinq, tanq, \
                        acosdq, asindq, atandq, atan2dq, cosdq, sindq, tandq, \
                        coshq, sinhq, tanhq, acoshq, asinhq, atanhq, expq, \
                        exp2q, exp10q, expm1q, logq, log2q, log10q, log1pq, \
                        powq, pownq, modfq, ldexpq, logbq, scalbq, \
                        scalbnq, scalblnq, ilogbq, fabsq, sqrtq, cbrtq, \
                        hypotq, compoundq, annuityq, erfq, erfcq, gammaq, \
                        lgammaq, tgammaq, ceilq, floorq, \
                        nearbyintq, rintq, roundq, lrintq, lroundq, \
                        truncq, nanq, fmodq, remainderq, copysignq, \
                        nextafterq, nexttowardq, fdimq, fmaxq, fminq, fmaq, \
                        rsqrtq
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#           pragma builtin powllnq, llrintq, llroundq 
#        endif /* defined(__STDC_EXT__) || ... */
         extern __float128 acosq(__float128);
         extern __float128 asinq(__float128);
         extern __float128 acosdq(__float128);
         extern __float128 asindq(__float128);
         extern __float128 atanq(__float128);
         extern __float128 atan2q(__float128, __float128);
         extern __float128 atandq(__float128);
         extern __float128 atan2dq(__float128, __float128);
         extern __float128 coshq(__float128);
         extern __float128 sinhq(__float128);
         extern __float128 tanhq(__float128);
         extern __float128 acoshq(__float128);
         extern __float128 asinhq(__float128);
         extern __float128 atanhq(__float128);
         extern __float128 cosq(__float128);
         extern __float128 sinq(__float128);
         extern __float128 tanq(__float128);
         extern __float128 cosdq(__float128);
         extern __float128 sindq(__float128);
         extern __float128 tandq(__float128);
         extern __float128 expq(__float128);
         extern __float128 exp2q(__float128);
         extern __float128 exp10q(__float128);
         extern __float128 expm1q(__float128);
         extern __float128 logq(__float128);
         extern __float128 log2q(__float128);
         extern __float128 log10q(__float128);
         extern __float128 log1pq(__float128);
         extern __float128 powq(__float128, __float128);
         extern __float128 pownq(__float128, int);
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
           extern __float128 powllnq(__float128, long long);
#        endif
         extern __float128 modfq(__float128, __float128 *);
         extern __float128 frexpq(__float128, int *);
         extern __float128 ldexpq(__float128, int);
         extern __float128 logbq(__float128);
         extern __float128 scalbq(__float128, __float128);
         extern __float128 scalbnq(__float128, int);
         extern __float128 scalblnq(__float128, long);
         extern int        ilogbq(__float128);
         extern __float128 fabsq(__float128);
         extern __float128 sqrtq(__float128);
         extern __float128 hypotq(__float128, __float128);
         extern __float128 cbrtq(__float128);
         extern __float128 compoundq(__float128, __float128);
         extern __float128 annuityq(__float128, __float128);
         extern __float128 erfq(__float128);
         extern __float128 erfcq(__float128);
         extern __float128 gammaq(__float128);
         extern __float128 lgammaq(__float128);
         extern __float128 lgammaq_r(__float128, int *);
         extern __float128 tgammaq(__float128);
         extern __float128 ceilq(__float128);
         extern __float128 floorq(__float128);
         extern __float128 nearbyintq(__float128);
         extern __float128 rintq(__float128);
         extern __float128 roundq(__float128);
         extern long      lrintq(__float128);
         extern long      lroundq(__float128);
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
           extern long long llrintq(__float128);
           extern long long llroundq(__float128);
#        endif
         extern __float128 truncq(__float128);
         extern __float128 nanq(const char *);
         extern __float128 fmodq(__float128, __float128);
         extern __float128 remainderq(__float128, __float128);
         extern __float128 remquoq(__float128, __float128, int *);
         extern __float128 copysignq(__float128, __float128);
         extern __float128 nextafterq(__float128, __float128);
         extern __float128 nexttowardq(__float128, __float128);
         extern __float128 fdimq(__float128, __float128);
         extern __float128 fmaxq(__float128, __float128);
         extern __float128 fminq(__float128, __float128);
         extern __float128 fmaq(__float128, __float128, __float128);
         extern __float128 rsqrtq(__float128);
#      endif /* _FPWIDETYPES */
#    endif /* __ia64 */
#  else /* not _PROTOTYPES */
     extern double copysign();
     extern double log2();
     extern double lgamma_r();
     extern double exp2();
     extern double fdim();
     extern double fmax();
     extern double fmin();
     extern double nan();
     extern double scalbn();
     extern double nearbyint();
     extern double round();
     extern double trunc();
     extern double remquo();
     extern long   lrint();
     extern long   lround();
     extern double cosd();
     extern double sind();
     extern double tand();
#    ifdef __ia64
       extern double    exp10();
       extern double    compound();
       extern double    annuity();
       extern double    fma();
       extern double    scalbln();
       extern double    tgamma();
       extern double    rsqrt();
#    endif
     extern double acosd();
     extern double asind();
     extern double atand();
     extern double atan2d();
#  endif /* _PROTOTYPES */

#endif /* _INCLUDE_HPUX_SOURCE */


/******** INTERNAL INTERFACE used in macro definitions ********/

#if defined(__cplusplus) || (defined(__ia64) && (!defined(_BIND_LIBCALLS) || \
  !defined(__HP_cc)))
#  define _DISALLOW_MASKING_MACROS
#endif

#ifdef __ia64
#  ifndef _LIBC
#    pragma extern _DINFINITY
#  endif
#endif
#ifdef _PROTOTYPES 
   extern const double _DINFINITY;
#else
   extern double _DINFINITY;
#endif

#ifdef _INCLUDE_HPUX_SOURCE

#  if defined(__ia64) && !defined(__cplusplus)
#    ifdef __HP_cc
#      if __HP_cc >= 112000 /* HPC */
#        define _ISDBL(x) __sametype((x),double) 
#        define _ISFLT(x) __sametype((x),float)
#        define _ISF80(x) __sametype((x),__float80)
#        define _ISF128(x) __sametype((x),__float128)
#      endif
#    else
#      define _IS64(x) (sizeof(x)==sizeof(double)) 
#      define _IS32(x) (sizeof(x)==sizeof(float))  
#      define _IS128(x) (sizeof(x)==sizeof(long double))  
#    endif
#  endif

#  ifdef _PA_RISC 
#    define _IS64(x) (sizeof(x)==sizeof(double)) 
#    define _IS32(x) (sizeof(x)==sizeof(float))  
#  endif

#  ifndef _DISALLOW_MASKING_MACROS
#    define nan(x) ((double)NAN)
#  endif

#  ifdef __ia64
#    ifndef _LIBC
#      pragma extern _SINFINITY, _LINFINITY, _WINFINITY, _SQNAN
#    endif
#  endif
#  ifdef _PROTOTYPES
     extern const float _SINFINITY;
#    ifdef __ia64
       extern const long double _LINFINITY;
#      pragma builtin _pown, _pownf, _pownl
       extern double _pown(double,int);
       extern float _pownf(float,int);
       extern long double _pownl(long double,int);
#      if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#        pragma builtin _powlln, _powllnf, _powllnl
         extern double _powlln(double,long long);
         extern float _powllnf(float,long long);
         extern long double _powllnl(long double,long long);
#      endif
#      ifdef _FPWIDETYPES
         extern const __float80 _WINFINITY;
#        pragma builtin _pownw, _pownq
         extern __float80 _pownw(__float80,int);
         extern __float128 _pownq(__float128,int);
#        if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#          pragma builtin _powllnw, _powllnq
           extern __float80 _powllnw(__float80,long long);
           extern __float128 _powllnq(__float128,long long);
#        endif
#      endif
#    endif
     extern const float _SQNAN;
#    ifdef __ia64
#      ifndef _DISALLOW_MASKING_MACROS
#        define nanf(x) ((float)NAN)
#        ifdef _FPWIDETYPES
#          define nanw(x) ((__float80)NAN)
#        endif 
#      endif
#      ifdef __cplusplus 
         /* C++ math.h provides the following as overloaded funtions */
#      else
#        ifdef __HP_cc
#          ifndef _INLINE_INCLUDED
#            include <machine/sys/inline.h>
#          endif
#          if __HP_cc >= 112000 /* HPC */
#            define _CLAMP(x) __select(_ISFLT(x),(__fpreg)(float)(x),_ISF80(x),(__fpreg)(__float80)(x),\
                  _ISDBL(x),(__fpreg)(double)(x),(__fpreg)(x)) 
#            define _ISNAN(x) __select(_ISF128(x),_Isnanf128(x),(int)_Asm_fclass((x),_FP_QNAN|_FP_SNAN))
#            define _ISINF(x) __select(_ISF128(x),_Isinff128(x),\
                  (int)_Asm_fclass(_CLAMP(x),_FP_INF|_FP_POS|_FP_NEG))
#            define _SIGNBIT(x) __select(_ISF128(x),_Signbitf128(x),(int)_Asm_getf(_FR_EXP,(x))>>17)
#            define _ISFINITE(x) __select(_ISF128(x),_Isfinitef128(x),\
                  (int)_Asm_fclass(_CLAMP(x),_FP_NORM|_FP_ZERO|_FP_UNNORM|_FP_POS|_FP_NEG))
#            define _ISNORMAL(x) __select(_ISF128(x),_Isnormalf128(x),\
                  (int)_Asm_fclass(_CLAMP(x),_FP_NORM|_FP_POS|_FP_NEG))
#            define _ISUNORDERED(x,y) __select(_ISF128(x)||_ISF128(y),_Isunorderedf128(x,y),\
                  (int)_Asm_fcmp(_FP_UNORD,(x),(y)))
#            define _ISGREATER(x,y) __select(_ISF128(x)||_ISF128(y),_Isgreaterf128(x,y),\
                  (int)_Asm_fcmp(_FP_GT,(x),(y),_SF1))
#            define _ISGREATEREQUAL(x,y) __select(_ISF128(x)||_ISF128(y),_Isgreaterequalf128(x,y),\
                  (int)_Asm_fcmp(_FP_GE,(x),(y),_SF1)) 
#            define _ISLESS(x,y) __select(_ISF128(x)||_ISF128(y),_Islessf128(x,y),\
                  (int)_Asm_fcmp(_FP_LT,(x),(y),_SF1)) 
#            define _ISLESSEQUAL(x,y) __select(_ISF128(x)||_ISF128(y),_Islessequalf128(x,y),\
                  (int)_Asm_fcmp(_FP_LE,(x),(y),_SF1))
#            define _FPCLASSIFY(x) __select(_ISFLT(x),_Fpclassf(x),_ISF80(x),\
               _Fpclassw(x),_ISF128(x),_Fpclassf128(x),_Fpclass(x))
#            define _ISLESSGREATER(x,y) __select(\
               _ISF128(x)||_ISF128(y),_Islessgreaterf128(x,y),\
               _ISF80(x)||_ISF80(y),_Islessgreaterw(x,y),\
               _ISDBL(x)||_ISDBL(y),_Islessgreater(x,y),_Islessgreaterf(x,y))
#          else
#            define _ISNAN(x) _Tgm_Isnan(x)
#            define _ISFINITE(x) _Tgm_Isfinite(x)
#            define _ISINF(x) _Tgm_Isinf(x)
#            define _ISNORMAL(x) _Tgm_Isnormal(x)
#            define _SIGNBIT(x) _Tgm_Signbit(x)
#            define _FPCLASSIFY(x) _Tgm_Fpclass(x)
#            define _ISUNORDERED(x,y) _Tgm_Isunordered(x,y)
#            define _ISLESS(x,y) _Tgm_Isless(x,y)
#            define _ISLESSEQUAL(x,y) _Tgm_Islessequal(x,y)
#            define _ISGREATER(x,y) _Tgm_Isgreater(x,y)
#            define _ISGREATEREQUAL(x,y) _Tgm_Isgreaterequal(x,y)
#            define _ISLESSGREATER(x,y) _Tgm_Islessgreater(x,y)
#          endif
#          ifndef _DISALLOW_MASKING_MACROS
#            define fabs(x)     ((double)_Asm_fabs((double)(x)))
#            define fabsf(x)    ((float)_Asm_fabs((float)(x)))
#            ifdef _FPWIDETYPES
#              define fabsw(x)    ((__float80)_Asm_fabs((__float80)(x)))
#            endif
#            define fma(x,y,z)  ((double)_Asm_fma(_PC_D,(double)(x),(double)(y),(double)(z)))
#            define fmaf(x,y,z) ((float)_Asm_fma(_PC_S,(float)(x),(float)(y),(float)(z)))
#            ifdef _FPWIDETYPES
#              define fmaw(x,y,z) ((__float80)_Asm_fma(_PC_NONE,(__float80)(x),(__float80)(y),(__float80)(z)))
#            endif
#            define copysign(x,y)  ((double)_Asm_fmerge(_FM_S,(double)(y),(double)(x)))
#            define copysignf(x,y) ((float)_Asm_fmerge(_FM_S,(float)(y),(float)(x)))
#            ifdef _FPWIDETYPES
#              define copysignw(x,y) ((__float80)_Asm_fmerge(_FM_S,(__float80)(y),(__float80)(x)))
#            endif
#            if defined(__STDC_EXT__) || defined(_INCLUDE_LONGLONG)
#              define llrint(x) ((long long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(double)(x))))
#              define llrintf(x) ((long long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(float)(x))))
#              ifdef _FPWIDETYPES
#                define llrintw(x) ((long long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(__float80)(x))))
#              endif
#            endif
#            ifdef _LP64
#              define lrint(x) ((long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(double)(x))))
#              define lrintf(x) ((long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(float)(x))))
#              ifdef _FPWIDETYPES
#                define lrintw(x) ((long)_Asm_getf(_FR_SIG,_Asm_fcvt_fx(_FX_S,(__float80)(x))))
#              endif
#            endif
#          endif /* masking macros */

#        else /* not __HP_cc (and no _INLINE_ASM) */
#          define _ISINF(x) (_IS32(x)?_Isinff(x):_IS128(x)?\
             _Isinff128(x):_Isinf(x))
#          define _ISNAN(x) (_IS32(x)?_Isnanf(x):_IS128(x)?\
             _Isnanf128(x):(isnan)(x))
#          define _ISFINITE(x) (_IS32(x)?_Isfinitef(x):_IS128(x)?\
             _Isfinitef128(x):_Isfinite(x))
#          define _ISNORMAL(x) (_IS32(x)?_Isnormalf(x):_IS128(x)?\
             _Isnormalf128(x):_Isnormal(x))
#          define _SIGNBIT(x) (_IS32(x)?_Signbitf(x):_IS128(x)?\
             _Signbitf128(x):_Signbit(x))
#          define _ISUNORDERED(x,y) \
             (_IS128(x)||_IS128(y)?_Isunorderedf128(x,y):\
             _IS64(x)||_IS64(y)?_Isunordered(x,y):_Isunorderedf(x,y))
#          define _ISLESS(x,y) \
             (_IS128(x)||_IS128(y)?_Islessf128(x,y):\
             _IS64(x)||_IS64(y)?_Isless(x,y):_Islessf(x,y))
#          define _ISLESSEQUAL(x,y) \
             (_IS128(x)||_IS128(y)?_Islessequalf128(x,y):\
             _IS64(x)||_IS64(y)?_Islessequal(x,y):_Islessequalf(x,y))
#          define _ISGREATER(x,y) \
             (_IS128(x)||_IS128(y)?_Isgreaterf128(x,y):\
             _IS64(x)||_IS64(y)?_Isgreater(x,y):_Isgreaterf(x,y))
#          define _ISGREATEREQUAL(x,y) \
             (_IS128(x)||_IS128(y)?_Isgreaterequalf128(x,y):\
             _IS64(x)||_IS64(y)?_Isgreaterequal(x,y):_Isgreaterequalf(x,y))
#          define _FPCLASSIFY(x) (_IS32(x)?_Fpclassf(x):_IS128(x)?\
             _Fpclassf128(x):_Fpclass(x))
#          define _ISLESSGREATER(x,y) \
             (_IS128(x)||_IS128(y)?_Islessgreaterf128(x,y):\
             _IS64(x)||_IS64(y)?_Islessgreater(x,y):_Islessgreaterf(x,y))
#        endif /* __HP_cc, _INLINE_ASM */
#      endif /* __cplusplus or not */
#    else /* PA_RISC */
#      ifndef _DISALLOW_MASKING_MACROS
#        define fabsf(x) ((float)fabs((double)(float)(x)))
#      endif
#      define _FPCLASSIFY(x)     (_IS32(x)?_Fpclassifyf(x)>>1:_Fpclassify(x)>>1)
#      define _ISNAN(x)          (_IS32(x)?_Isnanf(x):(isnan)(x))
#      define _ISINF(x)          (_IS32(x)?_Isinff(x):_Isinf(x))
#      define _ISFINITE(x)       (_IS32(x)?_Isfinitef(x):_Isfinite(x))
#      define _ISNORMAL(x)       (_IS32(x)?_Isnormalf(x):_Isnormal(x))
#      define _SIGNBIT(x)        (_IS32(x)?_Signbitf(x):_Signbit(x))
#      define _ISUNORDERED(x,y)  (_IS32(x)&&_IS32(y)?_Isunorderedf(x,y):_Isunordered(x,y))
#      define _ISLESS(x,y)       (_IS32(x)&&_IS32(y)?_Islessf(x,y):_Isless(x,y)) 
#      define _ISLESSEQUAL(x,y)  (_IS32(x)&&_IS32(y)?_Islessequalf(x,y):_Islessequal(x,y))
#      define _ISGREATER(x,y)    (_IS32(x)&&_IS32(y)?_Isgreaterf(x,y):_Isgreater(x,y))
#      define _ISGREATEREQUAL(x,y) (_IS32(x)&&_IS32(y)?_Isgreaterequalf(x,y):_Isgreaterequal(x,y))
#      define _ISLESSGREATER(x,y)  (_IS32(x)&&_IS32(y)?_Islessgreaterf(x,y):_Islessgreater(x,y))
#    endif /* __ia64 else PA_RISC */
#    if defined(__ia64) && defined(__HP_cc) && (__HP_cc < 112000) /* aCC C-mode */
       __inline int _Isnan(double x) { return (int)_Asm_fclass(x,_FP_QNAN|_FP_SNAN); }
       __inline int _Isfinite(double x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_ZERO|_FP_UNNORM|_FP_POS|_FP_NEG); }
       __inline int _Isinf(double x) { return (int)_Asm_fclass(x,_FP_INF|_FP_POS|_FP_NEG); }
       __inline int _Isnormal(double x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_POS|_FP_NEG); }
       __inline int _Signbit(double x) { return (int)_Asm_getf(_FR_EXP,x)>>17; }
       __inline int _Isunordered(double x,double y) { return (int)_Asm_fcmp(_FP_UNORD,x,y,_SF1); }
       __inline int _Isless(double x,double y) { return (int)_Asm_fcmp(_FP_LT,x,y,_SF1); }
       __inline int _Islessequal(double x,double y) { return (int)_Asm_fcmp(_FP_LE,x,y,_SF1); }
       __inline int _Isgreater(double x,double y) { return (int)_Asm_fcmp(_FP_GT,x,y,_SF1); }
       __inline int _Isgreaterequal(double x,double y) { return (int)_Asm_fcmp(_FP_GE,x,y,_SF1); }
       __inline int _Isnanf(float x) { return (int)_Asm_fclass(x,_FP_QNAN|_FP_SNAN); }
       __inline int _Isfinitef(float x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_ZERO|_FP_UNNORM|_FP_POS|_FP_NEG); }
       __inline int _Isinff(float x) { return (int)_Asm_fclass(x,_FP_INF|_FP_POS|_FP_NEG); }
       __inline int _Isnormalf(float x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_POS|_FP_NEG); }
       __inline int _Signbitf(float x) { return (int)_Asm_getf(_FR_EXP,x)>>17; }
       __inline int _Isunorderedf(float x,float y) { return (int)_Asm_fcmp(_FP_UNORD,x,y,_SF1); }
       __inline int _Islessf(float x,float y) { return (int)_Asm_fcmp(_FP_LT,x,y,_SF1); }
       __inline int _Islessequalf(float x,float y) { return (int)_Asm_fcmp(_FP_LE,x,y,_SF1); }
       __inline int _Isgreaterf(float x,float y) { return (int)_Asm_fcmp(_FP_GT,x,y,_SF1); }
       __inline int _Isgreaterequalf(float x,float y) { return (int)_Asm_fcmp(_FP_GE,x,y,_SF1); }
#      ifndef _DISALLOW_MASKING_MACROS
#        define fmax _Fmax
         __inline double _Fmax(double x, double y) {
           return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmax(x,y,_SF1);
         }
#        define fmin _Fmin
         __inline double _Fmin(double x, double y) {
           return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmin(x,y,_SF1);
         }
#        define fmaxf _Fmaxf
         __inline float _Fmaxf(float x, float y) {
           return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmax(x,y,_SF1);
         }
#        define fminf _Fminf
         __inline float _Fminf(float x, float y) {
           return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmin(x,y,_SF1);
         }
#      endif
#    else
       extern int _Isfinite(double);
       extern int _Isinf(double);
       extern int _Isnormal(double);
       extern int _Signbit(double);
       extern int _Isunordered(double, double);
       extern int _Isless(double, double);
       extern int _Islessequal(double, double);
       extern int _Isgreater(double, double);
       extern int _Isgreaterequal(double, double);
       extern int _Isnanf(float);
       extern int _Isfinitef(float);
       extern int _Isinff(float);
       extern int _Isnormalf(float);
       extern int _Signbitf(float);
       extern int _Isunorderedf(float, float);
       extern int _Islessf(float, float);
       extern int _Islessequalf(float, float);
       extern int _Isgreaterf(float, float);
       extern int _Isgreaterequalf(float, float);
#    endif /* defined(__ia64) && defined(__HP_cc) && (__HP_cc<112000) or not */
     extern int _Islessgreater(double, double);
     extern int _Islessgreaterf(float, float);
#    ifdef __ia64 
       extern int _Fpclass(double);
       extern int _Fpclassf(float);
#      ifdef _FPWIDETYPES
#        if defined(__HP_cc) && (__HP_cc < 112000) /* aCC C-mode */
#          
           __inline int _Isnanw(__float80 x) { return (int)_Asm_fclass(x,_FP_QNAN|_FP_SNAN); }
           __inline int _Isfinitew(__float80 x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_ZERO|_FP_UNNORM|_FP_POS|_FP_NEG); }
           __inline int _Isinfw(__float80 x) { return (int)_Asm_fclass(x,_FP_INF|_FP_POS|_FP_NEG); }
           __inline int _Isnormalw(__float80 x) { return (int)_Asm_fclass(x,_FP_NORM|_FP_POS|_FP_NEG); }
           __inline int _Signbitw(__float80 x) { return (int)_Asm_getf(_FR_EXP,x)>>17; }
       __inline int _Isunorderedw(__float80 x,__float80 y) { return (int)_Asm_fcmp(_FP_UNORD,x,y,_SF1); }
           __inline int _Islessw(__float80 x,__float80 y) { return (int)_Asm_fcmp(_FP_LT,x,y,_SF1); }
           __inline int _Islessequalw(__float80 x,__float80 y) { return (int)_Asm_fcmp(_FP_LE,x,y,_SF1); }
           __inline int _Isgreaterw(__float80 x,__float80 y) { return (int)_Asm_fcmp(_FP_GT,x,y,_SF1); }
           __inline int _Isgreaterequalw(__float80 x,__float80 y) { return (int)_Asm_fcmp(_FP_GE,x,y,_SF1); }
#          ifndef _DISALLOW_MASKING_MACROS
#            define fmaxw _Fmaxw
             __inline __float80 _Fmaxw(__float80 x, __float80 y) {
               return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmax(x,y,_SF1);
             }
#            define fminw _Fminw
             __inline __float80 _Fminw(__float80 x, __float80 y) {
               return _Asm_fclass(y,_FP_QNAN|_FP_SNAN)?x:_Asm_fmin(x,y,_SF1);
             }
#          endif
#        else
           extern int _Isnanw(__float80);
           extern int _Isfinitew(__float80);
           extern int _Isinfw(__float80);
           extern int _Isnormalw(__float80);
           extern int _Signbitw(__float80);
           extern int _Isunorderedw(__float80, __float80);
           extern int _Islessw(__float80, __float80);
           extern int _Islessequalw(__float80, __float80);
           extern int _Isgreaterw(__float80, __float80);
           extern int _Isgreaterequalw(__float80, __float80);
#        endif /* defined(__HP_cc) && (__HP_cc < 112000) or not */ 
         extern int _Islessgreaterw(__float80, __float80);
         extern int _Fpclassw(__float80);
#      endif /* _FPWIDETYPES */
       extern int _Isnanf128(long double);
       extern int _Isfinitef128(long double);
       extern int _Isinff128(long double);
       extern int _Isnormalf128(long double);
       extern int _Signbitf128(long double);
       extern int _Isunorderedf128(long double,long double);
       extern int _Islessf128(long double,long double);
       extern int _Islessequalf128(long double,long double);
       extern int _Isgreaterf128(long double,long double);
       extern int _Isgreaterequalf128(long double,long double);
       extern int _Islessgreaterf128(long double,long double);
       extern int _Fpclassf128(long double);
#    else /* PA_RISC */
       extern int _Fpclassify(double);
       extern int _Fpclassifyf(float);
#    endif /* __ia64 or _PA_RISC */
#  else /* NO PROTOTYPES */
     extern float _SINFINITY;
     extern float _SQNAN;
#    define _ISNAN(x)		((isnan)((double)(x)))
#    define _ISINF(x)		(_Isinf((double)(x)))
#    define _SIGNBIT(x)		(_Signbit((double)(x)))
#    define _ISFINITE(x)	(_Isfinite((double)(x)))
#    ifdef _PA_RISC
#      define _ISNORMAL(x)	(_IS32(x)?_Isnormalfd((double)(x)):_Isnormal((double)(x)))
#    else
#      define _ISNORMAL(x)	(_ISFLT(x)?_Isnormalfd((double)(x)):_Isnormal((double)(x)))
#    endif
#    define _ISUNORDERED(x,y) 	(_Isunordered((double)(x),(double)(y)))
#    define _ISLESS(x,y) 	(_Isless((double)(x),(double)(y)))
#    define _ISLESSEQUAL(x,y) 	(_Islessequal((double)(x),(double)(y)))
#    define _ISGREATER(x,y) 	(_Isgreater((double)(x),(double)(y)))
#    define _ISGREATEREQUAL(x,y) (_Isgreaterequal((double)(x),(double)(y)))
#    define _ISLESSGREATER(x,y)  (_Islessgreater((double)(x),(double)(y)))
#    ifdef _PA_RISC
#      define _FPCLASSIFY(x) (_IS32(x)?_Fpclassifyfd((double)(x))>>1:_Fpclassify((double)(x))>>1)
       extern int _Fpclassify();
       extern int _Fpclassifyfd();
#    else
#      define _FPCLASSIFY(x) (_ISFLT(x)?_Fpclassfd((double)(x)):_Fpclass((double)(x)))
       extern int _Fpclass();
       extern int _Fpclassfd();
#    endif
     extern int _Signbit();
     extern int _Isfinite();
     extern int _Isinf();
     extern int _Isnormal();
     extern int _Isnormalfd();
     extern int _Isunordered();
     extern int _Isless();
     extern int _Islessequal();
     extern int _Isgreater();
     extern int _Isgreaterequal();
     extern int _Islessgreater();
#  endif /* _PROTOTYPES */

#endif /* _INCLUDE_HPUX_SOURCE */

#ifdef __cplusplus
}
#endif


/******** PRE STANDARD C++ ****************************/

#if defined(__cplusplus) && (__cplusplus < 199707) && !defined(__GNUG__)
   
   
#  ifndef _STDLIB_INCLUDED
     extern "C" int abs(int);
#  endif /* _STDLIB_INCLUDED */
   
   inline double pow(double d,int expon) { return pow(d,(double)expon); }
#endif

#endif /* _MATH_INCLUDED */
